
From: Srivatsa Vaddagiri <vatsa@in.ibm.com>

During some signal test, we found that v_regs pointer was not setup
correctly.  v_regs was made to point to itself, as a result of which the
pointer was corrupted when vec registers were copied over.  When the signal
handler returned, restore_sigcontext tried derefering the invalid pointer
and in the process killed the app with SIGSEGV.

Signed-off-by: Srivatsa Vaddagiri <vatsa@in.ibm.com>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/arch/ppc64/kernel/signal.c |    2 +-
 1 files changed, 1 insertion(+), 1 deletion(-)

diff -puN arch/ppc64/kernel/signal.c~ppc64-fix-v_regs-pointer-setup arch/ppc64/kernel/signal.c
--- 25/arch/ppc64/kernel/signal.c~ppc64-fix-v_regs-pointer-setup	Wed Aug 18 17:30:08 2004
+++ 25-akpm/arch/ppc64/kernel/signal.c	Wed Aug 18 17:30:08 2004
@@ -127,7 +127,7 @@ static long setup_sigcontext(struct sigc
 	 * v_regs pointer or not
 	 */
 #ifdef CONFIG_ALTIVEC
-	elf_vrreg_t __user *v_regs = (elf_vrreg_t __user *)(((unsigned long)sc->vmx_reserve) & ~0xful);
+	elf_vrreg_t __user *v_regs = (elf_vrreg_t __user *)(((unsigned long)sc->vmx_reserve + 15) & ~0xful);
 #endif
 	long err = 0;
 
_
